/**
  Simple wrapper around operating system's
  memory manipulation routines.
  
  Orion Sky Lawlor, olawlor@acm.org, 2005/3/23 (Public Domain)
*/
#ifndef __OSL_MMAP_H
#define __OSL_MMAP_H

/**
  Represents a chunk of memory we've requested
  from the operating system.
*/
class memory_mapping {
public:
	/** Size, in bytes, of the smallest possible memory mapping.
	    Windows requires at least 64KB mappings.
	 */
	enum {page_size=64*1024};
	
	/** Make a memory mapping at this address covering
	   this many bytes. */
	memory_mapping(void *address,int len);

	/** Release this memory mapping. */
	~memory_mapping();
	
	/** Show the current set of mappings. */
	static void show(void);

private:
	void *addr; /**< Address where we mapped the memory */
	int len; /**< Number of bytes that were mapped */
};

#endif

